package com.wooshpay.controller;

import com.wooshpay.param.CreatePaymentIntentParam;
import com.wooshpay.service.PaymentIntentsService;
import com.wooshpay.vo.PaymentIntentVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.IOException;

@RestController
@Slf4j
public class PaymentIntentsController {

    @Resource
    private PaymentIntentsService paymentIntentService;

    @PostMapping("/create-payment-intent")
    public PaymentIntentVO create() throws IOException {
        CreatePaymentIntentParam param = new CreatePaymentIntentParam();
        param.setAmount(30l);
        param.setCurrency("CNY");
        return paymentIntentService.createPaymentIntent(param);
    }

    @RequestMapping("/index")
    public Object index(){
        return "ok";
    }
}
