package com.wooshpay.enums;

/**
 * @Author: liuyidao
 * @Description: 扣款方式枚举
 * @Date: 19:39 2022/3/1
 */
public enum CaptureMethodEnum {

    automatic("automatic", "自动确认"),
    manual("manual", "手动确认"),
    ;

    private String code;

    private String desc;

    CaptureMethodEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public String getCode() {
        return code;
    }


    public String getDesc() {
        return desc;
    }

    public static boolean isValidEnum(String code) {
        for (CaptureMethodEnum myEnum : CaptureMethodEnum.values()) {
            if (myEnum.getCode().equals(code)) {
                return true;
            }
        }
        return false;
    }
}