package com.wooshpay.enums;

/**
 * @Author: liuyidao
 * @Description: 客服端枚举
 * @Date: 19:39 2022/3/1
 */
public enum ClientEnum {
    WEB("web", "web"),
    IOS("ios", "ios"),
    ANDROID("android", "android"),
    ;

    private String code;

    private String desc;

    ClientEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public String getCode() {
        return code;
    }


    public String getDesc() {
        return desc;
    }


    public static boolean isValidEnum(String code) {
        for (ClientEnum myEnum : ClientEnum.values()) {
            if (myEnum.getCode().equals(code)) {
                return true;
            }
        }
        return false;
    }
}