package com.wooshpay.enums;

/**
 * @Author: liuyidao
 * @Description: 货币枚举
 * @Date: 19:39 2022/3/1
 */
public enum CurrencyEnum {

    EUR("EUR", "欧元"),
    GBP("GBP", "英镑"),
    CNY("CNY", "人民币"),
    USD("USD", "美元"),
    ;

    private String code;

    private String desc;

    CurrencyEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public String getCode() {
        return code;
    }


    public String getDesc() {
        return desc;
    }

    public static boolean isValidEnum(String code) {
        for (CurrencyEnum myEnum : CurrencyEnum.values()) {
            if (myEnum.getCode().equals(code)) {
                return true;
            }
        }
        return false;
    }
}