package com.wooshpay.enums;

import com.google.common.collect.Lists;

import java.util.List;

/**
 * @author zhujuntao
 * @date 2022/3/22 20:01
 * @description
 */
public enum PaymentMethodTypesEnum {
    CARD("card"),
    ALIPAY("alipay"),
    WECHAT_PAY("wechat_pay"),
    //UNION_PAY("union_pay"),
    ALIPAYPLUS("alipayplus"),
    KLARNA("klarna"),
    IDEAL("ideal"),
    GIROPAY("giropay"),
    SOFORT("sofort"),
    EPS("eps"),
    TRUSTLY("trustly"),
    BANCONTACT("bancontact"),
    /**
     * przelewy24
     */
    P24("p24"),
    SEPA("sepa"),
    /**
     * paydibs相关支付方式
     */
    UNION_PAY("unionpay"),
    BOOST("boost"),
    MCASH("mcash"),
    GRABPAY("grabpay"),
    TOUCH("touch_n_go"),
    DANA("dana");
    private String code;

    PaymentMethodTypesEnum(String code) {
        this.code = code;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public static List<String> toEnumStringList() {
        List<String> list = Lists.newArrayList();
        for (PaymentMethodTypesEnum paymentMethodTypesEnum : PaymentMethodTypesEnum.values()) {
            list.add(paymentMethodTypesEnum.code);
        }
        return list;
    }

    public static PaymentMethodTypesEnum getEnumByCode(String code) {
        for (PaymentMethodTypesEnum paymentMethodTypesEnum : PaymentMethodTypesEnum.values()) {
            if(paymentMethodTypesEnum.code.equals(code)) {
                return paymentMethodTypesEnum;
            }
        }

        return null;
    }
}
