package com.wooshpay.enums;

/**
 * @Author: liuyidao
 * @Description: 状态枚举
 * @Date: 19:39 2022/3/1
 */
public enum StatusEnum {

    PENDING("pending", "待处理"),
    SUCCEEDED("succeeded", "成功"),
    FAILED("failed", "失败"),
    RECEIVED("received", "已接收"),
    REQUIRES_PAYMENT_METHOD("requires_payment_method", "待补齐支付方式"),
    REQUIRES_CONFIRMATION("requires_confirmation", "待确认"),
    REQUIRES_ACTION("requires_action", "需要3ds认证"),
    PROCESSING("processing", "处理中"),
    CANCELED("canceled", "已取消"),
    ENABLED("enabled", "启用"),
    DISABLED("disabled", "禁用"),
    REQUIRES_CAPTURE("requires_capture", "待扣款"),
    ;

    private String name;

    private String desc;

    StatusEnum(String name, String desc) {
        this.name = name;
        this.desc = desc;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public static StatusEnum getStatusEnum(String status) {
        for (StatusEnum myEnum : StatusEnum.values()) {
            if (myEnum.getName().equalsIgnoreCase(status)) {
                return myEnum;
            }
        }
       return null;
    }
}