package com.wooshpay.param;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Positive;
import java.util.Map;

@Data
public class CreatePaymentIntentParam extends BaseUpdatePaymentIntentParam{

    @JsonProperty("merchant_order_id")
    private String merchantOrderId;
    @NotBlank(message = "currency is require")
    private String currency;
    @NotNull(message = "amount is require")
    @Positive(message = "amount must be greater than zero")
    private Long amount;
    private Boolean confirm;
    private Map<String, String> metadata;

    @JsonProperty("confirmation_method")
    private String confirmationMethod;

    /**
     * ONLY WHEN CONFIRM=TRUE
     */
    @JsonProperty("return_url")
    private String returnUrl;

    private String customer;
    /**
     *  automatic,manual
     */
    @JsonProperty("capture_method")
    private String captureMethod;
}
