package com.wooshpay.param;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import javax.validation.Valid;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

@Data
public class Shipping {

    @Valid
    @NotNull(message = "shipping.address is require")
    private DetailsAddress address;
    /**
     * The delivery service that shipped a physical product, such as FedEx, UPS, USPS, etc.
     */
    private String carrier;
    /**
     * Recipient name
     */
    @NotBlank(message = "shipping.name is require")
    private String name;
    /**
     * Recipient phone (including extension).
     */
    private String phone;

    /**
     * The tracking number for a physical product, obtained from the delivery service. If multiple tracking numbers were generated for this purchase, please separate them with commas.
     */
    @JsonProperty("tracking_number")
    private String trackingNumber;
}
