package com.wooshpay.service;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.nio.charset.StandardCharsets;
import java.util.Base64;
import java.util.Objects;
import java.util.UUID;
/**
 * @Author: liuyidao
 * @Description:
 * @Date: 17:19 2022/3/16
 */
public abstract class BaseService {
    protected static final String DOMAIN = "https://apitest.wooshpay.com";
    protected static ObjectMapper mapper = new ObjectMapper();

    static {
        mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
        mapper.setSerializationInclusion(JsonInclude.Include.NON_NULL);
    }

    protected String request(String url, Method method) throws JsonProcessingException {
        return request(url,method,null);
    }

    protected String request(String url, Method method, Object param) throws JsonProcessingException {
        HttpRequest request = HttpUtil.createRequest(method,DOMAIN+url).auth(getAuthorization()).header(" Idempotency-Key", UUID.randomUUID().toString());
        if (Objects.nonNull(param)){
            request = request.body(mapper.writeValueAsString(param));
        }
        String body = request.execute().body();
        System.out.println(body);
        return body;
    }

    abstract String getAuthorization();
}
