package com.wooshpay.service;

import cn.hutool.http.Method;
import com.wooshpay.param.CreatePaymentIntentParam;
import com.wooshpay.param.DetailsAddress;
import com.wooshpay.param.Shipping;
import com.wooshpay.vo.PaymentIntentVO;
import org.junit.Test;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.Base64;
import java.util.HashMap;
@Service
public class PaymentIntentsService extends BaseService {

    public String getAuthorization(){
        //This is your test secret API key.
        String name = "sk_test_dGVzdF9jaGVja291dDIyMjpJM3FwY2t5V1NuWVRnNnFPT3JEbXN2aUU=";
        String password = "";
        String sk = "Basic " + new String(Base64.getEncoder().encode((name + ":" + password).getBytes(StandardCharsets.UTF_8)));
        System.out.println(sk);
        return sk;
    }

    @Test
    public void createPaymentIntent() throws IOException {
        CreatePaymentIntentParam param = new CreatePaymentIntentParam();
        param.setCurrency("GBP");
        param.setAmount(13L);
        param.setConfirm(false);
        param.setReturnUrl("https://wooshpay.com");
        param.setMerchantOrderId("merchant order id");
        param.setDescription("product description");
        HashMap metadata = new HashMap();
        metadata.put("key1","value1");
        param.setMetadata(metadata);

        Shipping shipping = new Shipping();
        DetailsAddress shippingAddress = new DetailsAddress();
        shippingAddress.setCity("Greater London");
        shippingAddress.setCountry("GB");
        shippingAddress.setLine1("231 Bolton Ave");
        shippingAddress.setLine2("Apmt #101");
        shippingAddress.setPostalCode("E14 9XN");
        shippingAddress.setState("England");
        shipping.setAddress(shippingAddress);
        shipping.setPhone("7467764650");
        shipping.setName("Manuel Romero Gamero");
        shipping.setTrackingNumber("xxxxxxx");

        param.setShipping(shipping);
        param.setQuantity(1);
        PaymentIntentVO paymentIntentVO = createPaymentIntent(param);
        System.out.println(mapper.writeValueAsString(paymentIntentVO));
    }

    public PaymentIntentVO createPaymentIntent(CreatePaymentIntentParam param) throws IOException {
        String response = request("/v1/payment_intents", Method.POST, param);
        return mapper.readValue(response, PaymentIntentVO.class);
    }

    @Test
    public void queryPaymentIntent() throws IOException {
        String url = "/v1/payment_intents/pi_1623241402081083392";
        String response = request(url, Method.GET);
        PaymentIntentVO paymentIntentVO = mapper.readValue(response, PaymentIntentVO.class);
        System.out.println(mapper.writeValueAsString(paymentIntentVO));
    }
}
