package com.wooshpay.service;

import cn.hutool.http.Method;
import com.wooshpay.constants.EventConstants;
import com.wooshpay.param.CreateWebhookParam;
import com.wooshpay.vo.WebhookVO;
import org.junit.Test;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.Arrays;
import java.util.Base64;
import java.util.List;
/**
 * @Author: liuyidao
 * @Description:
 * @Date: 17:19 2022/3/16
 */
@Service
public class WebhookService extends BaseService {

    public String getAuthorization(){
        //This is your test secret API key.
        String name = "sk_test_dGVzdF9jaGVja291dDIyMjpJM3FwY2t5V1NuWVRnNnFPT3JEbXN2aUU=";
        String password = "";
        String sk = "Basic " + new String(Base64.getEncoder().encode((name + ":" + password).getBytes(StandardCharsets.UTF_8)));
        System.out.println(sk);
        return sk;
    }

    @Test
    public void createWebhook() throws Exception {
        String url ="/v1/webhook_endpoints";
        CreateWebhookParam param = new CreateWebhookParam();
        param.setApiVersion("1.0.1");
        param.setDescription("here is descripton");
        List<String> events = Arrays.asList(EventConstants.PAYMENT_INTENT_CREATED,
                EventConstants.PAYMENT_INTENT_PROCESSING,
                EventConstants.CHARGE_REFUND_UPDATED);
        param.setEnabledEvents(events);
        param.setUrl("https://apitest.wooshpay.com/v1/receives");
        String response = request(url, Method.POST,param);
        WebhookVO webhookVO = mapper.readValue(response, WebhookVO.class);
    }

    @Test
    public void queryWebhook() throws IOException {
        String url ="/v1/webhook_endpoints/we_1539227537211654144";
        String response = request(url, Method.GET);
        WebhookVO webhookVO = mapper.readValue(response, WebhookVO.class);
    }

    @Test
    public void deleteWebhook() throws IOException {
        String url ="/v1/webhook_endpoints/we_1539227537211654144";
        String response = request(url, Method.DELETE);
        WebhookVO webhookVO = mapper.readValue(response, WebhookVO.class);
    }
}
