package com.wooshpay.vo;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.wooshpay.param.PaymentMethodOptions;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.List;
import java.util.Map;

/**
 * @author zhujuntao
 * @date 2022/3/7 10:18
 * @description
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class PaymentIntentVO extends BasicVO {
    @JsonProperty("merchant_user_id")
    private String merchantUserId;

    @JsonProperty("merchant_order_id")
    private String merchantOrderId;

    private String currency;

    private Long amount;

    private String status;

    @JsonProperty("client_secret")
    private String clientSecret;

    private String description;

    @JsonProperty("last_payment_error")
    private LastPaymentError lastPaymentError;

    private Map<String, String> metadata;

    @JsonProperty("next_action")
    private NextAction nextAction;

    @JsonProperty("payment_method_types")
    private List<String> paymentMethodTypes;

    @JsonProperty("receipt_email")
    private String receiptEmail;

    @JsonProperty("canceled_at")
    private Long canceledAt;

    @JsonProperty("cancellation_reason")
    private String cancellationReason;

    @JsonProperty("confirmation_method")
    private String confirmationMethod;

    private Boolean livemode = false;

    @JsonProperty("payment_method_options")
    private PaymentMethodOptions paymentMethodOptions;

    @JsonProperty("3ds_status")
    private Status3DS status3ds;

    @JsonProperty("amount_capturable")
    private Long amountCapturable;

    private Shipping shipping;

    @JsonProperty("return_url")
    private String returnUrl;

    private Object customer;

    @JsonProperty("payment_method")
    private Object paymentMethod;

    private Integer quantity;

    @JsonProperty("amount_received")
    private Long amountReceived;

    /**
     * Possible enum values：automatic（默认），manual
     */
    @JsonProperty("capture_method")
    private String captureMethod;

    private Object invoice;
}
