package com.wooshpay.vo;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @Author: liuyidao
 * @Description: 3ds状态
 * @Date: 11:44 2022/3/15
 */
@Data
public class Status3DS implements Serializable {
    private static final long serialVersionUID = 2222575608441850325L;
    public static final String COMPLETED = "COMPLETED";
    public static final String PENDING = "PENDING";
    public static final String FAILED = "FAILED";
    private String cavv;
    /**
     * 5 – Identifies a successfully authenticated transaction.
     * 6 – Identifies an attempted authenticated transaction.
     * 7 – Identifies a non-authenticated transaction. Mastercard
     * 0 – Identifies a non-authenticated transaction.
     * 1 – Identifies an attempted authenticated transaction.
     * 2 – Identifies a successfully authenticated transaction.
     */
    private Integer eci;
    /**
     * COMPLETED – The transaction has been completed.
     * PENDING – The transaction has not been completed yet.
     * FAILED – The authentication request failed.
     */
    private String status;
    /**
     * Y – The cardholder successfully authenticated with their card issuer.
     * A – The cardholder authentication was attempted.
     * N – The cardholder failed to successfully authenticate with their card issuer.
     * U – Authentication with the card issuer was unavailable. C – Challenge Required; additional authentication is required. R – Rejected transaction.
     */
    @JsonProperty("three_d_result")
    private String threeDResult;
    /**
     *  Y – Cardholder authentication is available
     *  N – Cardholder is not enrolled in authentication
     *  U – Cardholder authentication unavailable
     */
    @JsonProperty("three_d_enrollment")
    private String threeDEnrollment;
    @JsonProperty("three_d_secure_version")
    private String threeDSecureVersion;
    /**
     * This is the transaction identifier returned by the card issuer. This exists only for 3DS 1.0.2.
     */
    private String xid;
    /**
     * The 3D Secure Server transaction Id. This exists only for 3D Secure 2.
     */
    @JsonProperty("three_d_secure_server_transaction_id")
    private String threeDSecureServerTransactionId;


      /* authentication.setCavv(jsonObject.getString("cavv"));
        authentication.setEci(Integer.valueOf(jsonObject.getString("eci")));
        authentication.setDirectoryServerTransactionId(jsonObject.getString("directoryServerTransactionId"));
        authentication.setThreeDEnrollment("Y");
        authentication.setThreeDSecureVersion(jsonObject.getString("threeDSecureVersion"));
        authentication.setThreeDResult(jsonObject.getString("threeDResult"));*/
}
